=== debian/changelog ===
siconos (4.3.1+dfsg-2) unstable; urgency=medium

  * Disable test ContactTest due to timeout on arm64.
  * Disable test ConvexQP_test_collection due to timeout.

 -- Stephen Sinclair <radarsat1@gmail.com>  Mon, 25 Jan 2021 19:50:26 +0100

siconos (4.3.1+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Rebase patches:
    + Remove upstreamed patch to FindLAPACK.cmake.
  * Update policy version 4.5.1.
  * Update debhelper version 13.
  * Add missing symbols for numerics.
  * Change architecture for siconos and siconos-mechanics-tools to all.
  * Add debian/upstream/metadata.
  * Replace debian/compat with debhelper-compat package.

 -- Stephen Sinclair <radarsat1@gmail.com>  Sat, 12 Dec 2020 18:31:54 +0000

siconos (4.3.0+dfsg-3) unstable; urgency=medium

  * Patch to fix indexing bug in siconos_filter program.  (Closes: #974184)
  * Patch to suppress a warning due to CMake's FindBoost in siconos script.

 -- Stephen Sinclair <radarsat1@gmail.com>  Sat, 28 Nov 2020 22:00:41 +0000

siconos (4.3.0+dfsg-2) unstable; urgency=medium

  * Set Python3_EXECUTABLE instead of PYTHON_EXECUTABLE.
    (Closes: #972394)
  * Skip test dr_iso1 due to occasional timeout.

 -- Stephen Sinclair <radarsat1@gmail.com>  Tue, 27 Oct 2020 19:05:25 +0000
